<template>
  <v-card>
    <v-card-text>
      <v-row v-for="param in params" :key="param.name">
        <v-col cols="4">
          <v-subheader>{{ param.name }}</v-subheader>
        </v-col>
        <v-col cols="8">
          <v-text-field
            :label="param.type"
            :key="param.name"
            v-model="param.value"
          ></v-text-field>
        </v-col>
      </v-row>
    </v-card-text>
  </v-card>
</template>

<script>
export default {
  name: "Proposal",
  props: [ "value", "signature" ],
  data() {
    return {
      paramDefs: []
    }
  },
  computed: {
    params: {
      get() {
        return this.value;
      },
      set(value) {
        this.$emit('input', value);
      }
    }
  },
  watch: {
    signature: {
      handler(newValue, ) {
        const params = [];

        newValue.inputs.forEach((paramDef) => {
          params.push({ name: paramDef.name, value: "" });
        });

        this.params = params;
      },
      deep: true,
      immediate: true
    }
  }
}
</script>
